
-- Initialize the variables
local _CurrentRealm = GetRealmName();
local _CurrentPlayerName = UnitName("player");

--[[
CharRecords = {};
CharRecords[Server] = {};
CharRecords[Server][CurrentPlayerName] = {};


Inventory = {};
Inventory[Server] = {};
Inventory[Server][CurrentPlayerName] = {};
]]--

function Banker_OnLoad()

	BankerFrame:RegisterEvent("BANKFRAME_CLOSED");
	BankerFrame:RegisterEvent("BANKFRAME_OPENED");

	BankerFrame:RegisterEvent("PLAYER_LOGOUT");

	BankerFrame:RegisterEvent("MAIL_CLOSED");
	BankerFrame:RegisterEvent("MAIL_SHOW");
	
	if not Inventory then
		Inventory = {}
	end
	initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Inventory")
	initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Time")
	
	Inventory[_CurrentRealm][_CurrentPlayerName]["Time"]["OnLoad"] = time();

	BankerLoadTime = GetTime()
end



function Banker_OnEvent(self,event,...)

	recordTimeOfEvent(event)
	
	if "BANKFRAME_OPENED"==event then
		local toi = TableOfInventory()
		
		if not Inventory then
			Inventory = {}
		end
		initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Inventory")
		initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Time")
		
		Inventory[_CurrentRealm][_CurrentPlayerName]["Inventory"] = toi;
		Inventory[_CurrentRealm][_CurrentPlayerName]["Time"]["Updated"] = time();
		
		local size = tablelength(toi)
		
		print("Banker Updated: " .. ColorText(255,102,00) .. size .. ColorText() );
		
	end
	
end

local eventIdNumber = 0

function recordTimeOfEvent(event)

	local Server = GetRealmName();
	local CurrentPlayerName = UnitName("player");

	if not CharRecords then
		CharRecords = {};
	end
	
	if not CharRecords[Server] then
		CharRecords[Server] = {};
	end
	
	if not CharRecords[Server][CurrentPlayerName] then
		CharRecords[Server][CurrentPlayerName] = {};
	end
	
	if not CharRecords[Server][CurrentPlayerName][event] then
		CharRecords[Server][CurrentPlayerName][event] = {};
	end
	
	CharRecords[Server][CurrentPlayerName][event]["GetTime"] = GetTime();
	CharRecords[Server][CurrentPlayerName][event]["time"] = time();
	
	CharRecords[Server][CurrentPlayerName][event]["eventIdNumber"] = eventIdNumber;

	eventIdNumber = eventIdNumber + 1
end


function Banker_OnUpdate()

end

